

/* Interfaccia del programma: compitoA  Stringa NomeFile */

/* Il processo iniziale P0 deve generare tre processi figli, che si pongono in attesa */

/* di comandi. P0 deve ordinare ai figli con PID pari di scrivere Stringa su NomeFile, */

/* mentre deve ordinare ai figli con PID dispari di leggere l'intero file NomeFile */

/* solo quando tutti i processi scrittori hanno terminato le loro operazioni. */





#include <stdio.h>

#include <signal.h>

#include <fcntl.h>

#define BUFSIZE 80





void handler1(int sig_no);

void handler2(int sig_no);

int fd;

char param1[BUFSIZE];







main(int argc,char **argv)



{int i,pid[3],status,numeropari;



if (argc!=3)

	{printf("Il programma prevede due argomenti\n");

	exit(1);

	}

strcpy(param1,argv[1]);

if ((fd=open(argv[2],O_RDWR|O_CREAT,0744))<0)

	{printf("Errore nell'apertura del file\n");

	exit(2);

	}



signal(SIGUSR1,handler1);

signal(SIGUSR2,handler2);



for (i=0;i<3;i++)

	{if ((pid[i]=fork())<0)

		{printf("Errore nella fork %d\n",i);

		exit(3);

		}

	if (pid[i]==0) pause();

	}



sleep(1);

printf("Sono il padre e invio i segnali ai figli pari\n");

for (i=0;i<3;i++)

	if ((pid[i]%2)==0) 

		{numeropari++;

		kill(pid[i],SIGUSR1);

		}

		

for (i=0;i<numeropari;i++) wait(&status);	



for (i=0;i<3;i++) /* Invio i segnali ai figli dispari */

	if ((pid[i]%2)==1) kill(pid[i],SIGUSR2);			



for (i=0;i<(3-numeropari);i++) wait(&status);



exit(0);

}





void handler1(int sig_no)

{int nwrite;



printf("Processo %d: scrivo...\n",getpid());

if ((nwrite=write(fd,param1,BUFSIZE))<strlen(param1))

	{printf("Errore scrittura su file\n"); 

	exit(4); 

	}

close(fd);

exit(0);

}



void handler2(int sig_no)

{int nread;

char buf[BUFSIZE];



printf("Processo %d: leggo...\n",getpid());

printf("Contenuto del file:\n");

lseek(fd,SEEK_SET,0);

while ((nread=read(fd,buf,BUFSIZE))>0)

	printf("%s\n",buf);	

close(fd);

exit(0);

}

